﻿Public Class fmMain

    Private Sub fmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        tbTableName.Text = "AD_" & Format(Now(), "yyMMdd")
    End Sub

    Private Sub bnBrowse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnBrowse.Click
        SaveFileDialog1.AddExtension = True
        SaveFileDialog1.FileName = tbDatabase.Text
        SaveFileDialog1.DefaultExt = "mdb"
        SaveFileDialog1.Filter = "Microsoft Access files (*.mdb)|*.mdb|All files (*.*)|*.*"
        SaveFileDialog1.InitialDirectory = tbDatabase.Text
        SaveFileDialog1.CheckFileExists = False
        SaveFileDialog1.OverwritePrompt = False
        If SaveFileDialog1.ShowDialog() = DialogResult.OK Then
            tbDatabase.Text = SaveFileDialog1.FileName
        End If
    End Sub

    Private Sub bnQuit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnQuit.Click
        Me.Close()
    End Sub

    Private Sub cbListType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbListType.SelectedIndexChanged
        Select Case cbListType.Text
            Case "Browse List (My Network Places)"
                tbDomain.Enabled = False
                tbOUFilter.Enabled = False
                cbLevel.Enabled = Enabled
                tbTableName.Text = "Browse_" & Format(Now(), "yyMMdd")
            Case "NT-Style Domain list"
                tbDomain.Enabled = True
                tbOUFilter.Enabled = False
                cbLevel.Enabled = False
                tbTableName.Text = "NT_" & Format(Now(), "yyMMdd")
            Case "Active Directory OU List"
                tbDomain.Enabled = True
                tbOUFilter.Enabled = True
                cbLevel.Enabled = False
                tbTableName.Text = "AD_" & Format(Now(), "yyMMdd")
            Case Else
                Beep()
        End Select
    End Sub

    Private Sub bnDoit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles bnDoit.Click
        Dim db As AccessDatabase
        Dim DDL As String
        Dim dt As DataTable
        Dim net As GetNetInfo

        db = New AccessDatabase
        Try
            ' Does the database already exist?  If not, create it!
            db.CreateDatabase(tbDatabase.Text)
        Catch ex As Exception
            MsgBox("Can not create the database" & vbCr & ex.Message, MsgBoxStyle.Critical, "Error")
            Exit Sub
        End Try

        ' whack the existing table?
        Try
            If db.TableExists(tbDatabase.Text, tbTableName.Text) Then
                Select Case MsgBox("Database table already exists, Overwrite the contents?", MsgBoxStyle.YesNoCancel, "Warning")
                    Case MsgBoxResult.Yes
                        db.EmptyTable(tbDatabase.Text, tbTableName.Text)
                    Case MsgBoxResult.No
                        ' do nothing
                    Case MsgBoxResult.Cancel
                        Exit Sub
                End Select
            End If

            ' Create a new table (if we need to)
            DDL = "(ID int identity primary key, " _
            & "PCDomain varchar(150), " _
            & "PCName varchar(50), " _
            & "OSVersion double, " _
            & "Services varchar(100), " _
            & "PCComment varchar(255))"
            db.CreateTable(tbDatabase.Text, tbTableName.Text, DDL)
        Catch ex As Exception
            MsgBox("Can not create the table" & vbCr & ex.Message, MsgBoxStyle.Critical, "Error")
            Exit Sub
        End Try

        ' Open the database
        Try
            dt = db.OpenTable(tbDatabase.Text, tbTableName.Text)
        Catch ex As Exception
            MsgBox("Can not open the database" & vbCr & ex.Message, MsgBoxStyle.Critical, "Error")
            Exit Sub
        End Try

        ' OK, let's do it!
        net = New GetNetInfo
        lbStatus.Text = "Running..."
        Me.Cursor = Cursors.WaitCursor
        Application.DoEvents()
        Select Case cbListType.Text
            Case "Browse List (My Network Places)"
                net.GetPCBrowseInfo(dt, tbDomain.Text, tbNameFilter.Text)
            Case "NT-Style Domain list"
                net.GetPCDomInfo(dt, tbDomain.Text, tbNameFilter.Text)
            Case "Active Directory OU List"
                net.GetPCOUInfo(dt, tbDomain.Text, tbOUFilter.Text, tbNameFilter.Text, False)
            Case Else
                Me.Cursor = Cursors.Default
                lbStatus.Text = "Ready"
                MsgBox("Not a supported list type", MsgBoxStyle.Critical, "Input Error")
                Exit Sub
        End Select

        ' save the data we've collected
        lbStatus.Text = "Saving..."
        Application.DoEvents()
        db.UpdateTable(dt)

        Me.Cursor = Cursors.Default
        lbStatus.Text = "Done"
        MsgBox("recorded " & dt.Rows.Count & " rows")
        lbStatus.Text = "Ready"
    End Sub
End Class
